<template>
    <div class="wrapper">

      <div class="header">

        <router-link :to="{ name: 'choose-card' }">
          <div
            :style="`background-image: url(${require('@/assets/img/arrow-back.svg')})`"
            class="arrow-back-button"
          ></div>
        </router-link>
       
        Добавить карту
      </div>
      
      <div v-if="$store.state.tips.addCard" class="tip">
        Введите данные карты, которую планируете использовать для оплаты
        <div @click="$store.commit('SET_TIP_STATUS', { tip: 'addCard', status: false })" :style="`background-image: url(${require('@/assets/img/cross.svg')})`" class="cross-icon">
        </div>
      </div>
      
      <div class="input-wrapper">
        <input
          class="input"
          type="tel"
          @input="cardID = $event.target.value"
          placeholder="Номер карты"
          v-mask="'#### #### #### ####'"
        />
      </div>

      <div class="input-wrapper">
        <input
          class="input"
          type="text"
          placeholder="Имя на карте"
          v-model="cardName"
          @input="cardNameValidation($event)"
        />
      </div>

      <div @click="mainButtonHandler($event)" class="save-button">Сохранить карту</div>

      <router-link :to="{ name: 'choose-card' }">
        <div class="cancel">Отменить</div>
      </router-link>

    </div>
</template>

<script>
import { mask } from "vue-the-mask";
import {createRipple} from "@/utils/animations.js"

export default {
  directives: {
    mask,
  },
  data() {
    return {
      cardID: '', 
      cardName: ''
    }
  },

  methods: {
    createRipple,

    mainButtonHandler(event) {
      this.createRipple(event); 

      if (this.cardID.length === 19) {
        setTimeout(() => {

          const data = {
            card_id: (Math.random() * 1000000).toString(),
            card_mask: this.cardID.toString(),
            card_type: "VISA",
            issuer: "Kaspi Bank",
            name: this.cardName,
            is_main: true,
          }

          this.$store.dispatch('saveCard', { data });
          this.$router.push({ name: 'choose-card' });
        }, 200);
      }
      
    },

    cardNameValidation(e) {
      if (/[^ a-z'`~.-]/gi.test(e.target.value)) {
        e.target.value = e.target.value.replace(/[^ a-z'`~.-]/gi, '');
      }
    },
  }
}
</script>

<style scoped>
@import '../styles/styles.css';
</style>